import * as tslib_1 from "tslib";
import TheRoot from "./components/TheRoot.js";
import { routes } from "./router/routes";
import registerPlugin from "./plugin/registerPlugin";
// Initializers
import * as vuex from "./plugin/initializers/store";
import MetaInfo from "vue-meta-info";
export var ModulePrefix = "wp";
export default {
    install: function (Vue, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var store, manualVuexMode, _i, _a, plugin, router, nuxtServer, html, el, url, e_1;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 3, , 4]);
                        // Config
                        // Is it proper
                        // if (!('config' in options)) {
                        //   throw new Error('No config provided!')
                        // }
                        if (!("url" in options)) {
                            throw new Error("No API's URL provided!");
                        }
                        if (!("lang" in options)) {
                            throw new Error("No lang provided!");
                        }
                        // Register it in app
                        Vue.use(MetaInfo);
                        Vue.prototype.$wp = {};
                        Vue.prototype.$wp.config = options;
                        // Do we have store?
                        if (!("store" in options)) {
                            throw new Error("No VueX store provided in config!");
                        }
                        store = void 0;
                        manualVuexMode = options.store === true;
                        if (!manualVuexMode) {
                            store = options.store;
                        }
                        // Global access to TheRoot component
                        Vue.component("Sections", TheRoot);
                        // Register VueX modules
                        if (!manualVuexMode)
                            vuex.registerModules(store);
                        if ("plugins" in options) {
                            // Register plugins
                            if (Array.isArray(options.plugins)) {
                                for (_i = 0, _a = options.plugins; _i < _a.length; _i++) {
                                    plugin = _a[_i];
                                    registerPlugin(Vue, plugin, store);
                                }
                            }
                            else {
                                registerPlugin(Vue, options.plugins, store);
                            }
                        }
                        if (!!manualVuexMode) return [3 /*break*/, 2];
                        return [4 /*yield*/, vuex.loadBase(store.dispatch, options.hasOwnProperty("menus") ? options.menus : true)];
                    case 1:
                        _b.sent();
                        vuex.setLang(store.commit, options.lang);
                        vuex.setConfig(store.commit, options);
                        _b.label = 2;
                    case 2:
                        // Do we have router?
                        if (!("router" in options)) {
                            throw new Error("No router instance provided in config!");
                        }
                        router = options.router;
                        if (typeof router === "object") {
                            router.addRoutes(routes());
                        }
                        nuxtServer = process && process.server;
                        if (!nuxtServer && document !== undefined) {
                            html = document.querySelector("html");
                            if (html) {
                                html.setAttribute("lang", options.lang);
                            }
                            el = document.createElement("link");
                            el.setAttribute("rel", "alternate");
                            url = window.location.origin.substr(-1) === "/"
                                ? window.location.origin
                                : window.location.origin + "/";
                            el.setAttribute("href", "" + url + options.lang);
                            el.setAttribute("hreflang", "" + options.lang);
                            document.head.appendChild(el);
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        console.error(e_1, e_1.message);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
};
//# sourceMappingURL=index.js.map