import { isLoaderRequestElement } from "../types";
function pickMetaSource(loaderRequest) {
    var type = "pages";
    if (typeof loaderRequest === "string") {
        return {
            slug: loaderRequest,
            type: type
        };
    }
    else if (isLoaderRequestElement(loaderRequest)) {
        if (loaderRequest.hasOwnProperty("post")) {
            type = loaderRequest.post;
        }
        return {
            slug: "dataName" in loaderRequest
                ? loaderRequest.dataName
                : loaderRequest.slug,
            type: type
        };
    }
    else if (Array.isArray(loaderRequest)) {
        var current = null;
        var reversedLoader = loaderRequest.slice().reverse();
        for (var _i = 0, reversedLoader_1 = reversedLoader; _i < reversedLoader_1.length; _i++) {
            var request = reversedLoader_1[_i];
            var tmp = pickMetaSource(request);
            if (current === null) {
                current = tmp;
                type = current.type;
            }
            if (isLoaderRequestElement(request) &&
                "meta" in request &&
                request.meta === true) {
                type = current.type;
                return {
                    slug: tmp,
                    type: type
                };
            }
        }
        return current;
    }
    else {
        throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
    }
}
export default pickMetaSource;
//# sourceMappingURL=PickMetaSource.js.map