import * as tslib_1 from "tslib";
import { isLoaderRequestElement } from "../../../types";
import { ModulePrefix } from "../../../";
import Meta from "../../meta";
import pickMetaSource from "../../PickMetaSource";
import buildComputed from "../builders/Computed";
var buildCreated = function (loaderRequest) {
    return function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var isPost, contentType, requests, _i, loaderRequest_1, request;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(typeof loaderRequest === "string")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: loaderRequest,
                                type: "pages"
                            })];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 2:
                        if (!isLoaderRequestElement(loaderRequest)) return [3 /*break*/, 4];
                        isPost = "type" in loaderRequest;
                        contentType = isPost ? loaderRequest.type : "pages";
                        return [4 /*yield*/, this.$store.dispatch(ModulePrefix + "_post/load", {
                                slug: loaderRequest.slug,
                                type: contentType
                            })];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 4:
                        if (!Array.isArray(loaderRequest)) return [3 /*break*/, 6];
                        requests = [];
                        for (_i = 0, loaderRequest_1 = loaderRequest; _i < loaderRequest_1.length; _i++) {
                            request = loaderRequest_1[_i];
                            if (typeof request !== "string" && !isLoaderRequestElement(request)) {
                                throw new Error("FetchHookType Created: Bad loaderRequest");
                            }
                            requests.push(buildCreated.call(this, request).call(this));
                        }
                        return [4 /*yield*/, Promise.all(requests)];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6: throw new Error("FetchHookTypeCreated: loaderRequest cannot be " + typeof loaderRequest);
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
};
export default (function (loaderRequest, setMeta) {
    var returnable = {
        created: buildCreated(loaderRequest),
        computed: buildComputed(loaderRequest)
    };
    if (setMeta) {
        var _a = pickMetaSource(loaderRequest), type = _a.type, slug = _a.slug;
        returnable.mixins = [Meta(type, slug)];
    }
    return returnable;
});
//# sourceMappingURL=Created.js.map