import { FetchHookTypes } from "../../types";
import fhtCreated from "./fetchHookTypes/Created";
import fhtAsyncData from "./fetchHookTypes/AsyncData";
import fhtVoidAsyncData from "./fetchHookTypes/VoidAsyncData";
export default (function (loaderRequest, fht, setMeta) {
    if (fht === void 0) { fht = FetchHookTypes.Created; }
    if (setMeta === void 0) { setMeta = true; }
    switch (fht) {
        case FetchHookTypes.Created:
            return fhtCreated(loaderRequest, setMeta);
        case FetchHookTypes.AsyncData:
            return fhtAsyncData(loaderRequest, setMeta);
        case FetchHookTypes.VoidAsyncData:
            return fhtVoidAsyncData(loaderRequest, setMeta);
        default:
            throw new Error("FetchHookType" + fht + " does not exist");
    }
});
//# sourceMappingURL=index.js.map